exec("./guiMods.cs");

package Env_LoadSave
{
	//Called when starting load
	function LoadBricks_ClickLoadButton()
	{
		$LoadBricksName = filterOutString(getField(LoadBricks_FileList.getValue(),0),"/");
		Parent::LoadBricks_ClickLoadButton();
	}
	
	//Called when loading is finished
	function handleProcessComplete(%type,%msg)
	{
		Parent::handleProcessComplete(%type,%msg);
		if(LoadBricks_Environment.getValue()) //Load the environment after brick loading is complete
			LoadBricks_LoadEnvironment(); 
	}
	
	//Called when the save button is clicked
	function SaveBricks_Save()
	{
		EnvGui.onWake(); //Appears to be the easiest way to update the client with environment settings from the server. Doing it now so it has some time to update before saving.
		$SaveBricksName = SaveBricks_FileName.getValue();
		Parent::SaveBricks_Save();
	}
	
	//Returns when saving is finished
	function SavingGui::Save()
	{
		Parent::Save();
		if(SaveBricks_Environment.getValue())  //Save the environment after we save bricks
			SaveBricks_SaveEnvironment();
	}
	
	//Support for Siba's Delete extension
	function DeleteSave_Confirm()
	{
		%fileName=getField($DelGui.getValue(),0);
		%file = "saves/" @ %fileName @ ".ble";
		Parent::DeleteSave_Confirm();
		if(isFile(%file))
			fileDelete(%file);
	}
};
ActivatePackage(Env_LoadSave);

function LoadBricks_LoadEnvironment()
{
	%fileName = "saves/" @ $LoadBricksName @ ".ble";
	if(!isFile(%fileName))
		return;
	
	%file = new FileObject();
	%file.openForRead(%fileName);
	%file.readLine(); %file.readLine(); %file.readLine(); //Read a few lines to skip paste what we don't want
	while(!%file.isEof())
	{
		%line = %file.readLine();
		%var = getField(%line,0);
		%val = getField(%line,1);
		commandtoserver('envGui_SetVar',%var,%val);
	}
	%file.close();
	%file.delete();
}

function SaveBricks_SaveEnvironment()
{
	//Write the .ble environment file
	if($EnvGui::SkyIdx $= "") //Not having the environment settings could be caused by a few things, such as not being an admin on the server.
	{
		echo("Could not save environment.");
		return;
	}
	
	%file = new FileObject();
	%file.openForWrite("saves/" @ $SaveBricksName @ ".ble");
	%file.writeLine("This is a Blockland Environment file generated by Adam487's Save/Load Bricks Extension: Environment");
	%file.writeLine("You probably shouldn't modify it cause you'll screw it up.");
	%file.writeLine("");
	%file.writeLine("WaterIdx" 			TAB $EnvGui::WaterIdx);
	%file.writeLine("SkyIdx" 			TAB $EnvGui::SkyIdx);
	%file.writeLine("GroundIdx" 		TAB $EnvGui::GroundIdx);
	
	%file.writeLine("DayOffset" 		TAB $EnvGui::DayOffset);
	%file.writeLine("DayLength" 		TAB $EnvGui::DayLength);
	%file.writeLine("DayCycleEnabled" 	TAB $EnvGui::DayCycleEnabled);
	%file.writeLine("DayCycleIdx" 		TAB $EnvGui::DayCycleIdx);
	%file.writeLine("SunAzimuth" 		TAB $EnvGui::SunAzimuth);
	%file.writeLine("SunElevation" 		TAB $EnvGui::SunElevation);
	%file.writeLine("DirectLightColor" 	TAB $EnvGui::DirectLightColor);
	%file.writeLine("AmbientLightColor" TAB $EnvGui::AmbientLightColor);
	%file.writeLine("ShadowColor" 		TAB $EnvGui::ShadowColor);
	%file.writeLine("SunFlareColor" 	TAB $EnvGui::SunFlareColor);
	%file.writeLine("SunFlareSize" 		TAB $EnvGui::SunFlareSize);
	%file.writeLine("SunFlareTopIdx" 	TAB $EnvGui::SunFlareTopIdx);
	%file.writeLine("SunFlareBottomIdx" TAB $EnvGui::SunFlareBottomIdx);
	%file.writeLine("VisibleDistance" 	TAB $EnvGui::VisibleDistance);
	%file.writeLine("FogDistance" 		TAB $EnvGui::FogDistance);
	%file.writeLine("FogHeight" 		TAB $EnvGui::FogHeight);
	%file.writeLine("FogColor" 			TAB $EnvGui::FogColor);
	%file.writeLine("WaterColor" 		TAB $EnvGui::WaterColor);
	%file.writeLine("WaterHeight" 		TAB $EnvGui::WaterHeight);
	%file.writeLine("UnderWaterColor" 	TAB $EnvGui::UnderWaterColor);
	%file.writeLine("SkyColor" 			TAB $EnvGui::SkyColor);
	%file.writeLine("WaterScrollX" 		TAB $EnvGui::WaterScrollX);
	%file.writeLine("WaterScrollY" 		TAB $EnvGui::WaterScrollY);
	%file.writeLine("GroundColor" 		TAB $EnvGui::GroundColor);
	%file.writeLine("GroundScrollX" 	TAB $EnvGui::GroundScrollX);
	%file.writeLine("GroundScrollY" 	TAB $EnvGui::GroundScrollY);
	%file.writeLine("VignetteMultiply" 	TAB $EnvGui::VignetteMultiply);
	%file.writeLine("VignetteColor" 	TAB $EnvGui::VignetteColor);
	%file.writeLine("SimpleMode" 		TAB $EnvGui::SimpleMode);
	
	%file.close();
	%file.delete();
}